import { ConfigurationMapper } from '@modules/configuration/configuration.mapper';
import { ConfigurationRepository } from '@modules/configuration/infrastructure/configuration.repository';
import { PrismaService } from '@modules/configuration/infrastructure/prisma.service';
import { EventEmitter2, EventEmitterModule } from '@nestjs/event-emitter';
import { Test, TestingModule } from '@nestjs/testing';

const mockMessagePublisher = {
  publish: jest.fn().mockImplementation(),
};

describe('Configuration repository', () => {
  let prismaService: PrismaService;
  let configurationMapper: ConfigurationMapper;
  let eventEmitter: EventEmitter2;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [EventEmitterModule.forRoot()],
      providers: [PrismaService, ConfigurationMapper],
    }).compile();

    prismaService = module.get<PrismaService>(PrismaService);
    configurationMapper = module.get<ConfigurationMapper>(ConfigurationMapper);
    eventEmitter = module.get<EventEmitter2>(EventEmitter2);
  });
  it('should be defined', () => {
    expect(
      new ConfigurationRepository(
        prismaService,
        configurationMapper,
        eventEmitter,
        mockMessagePublisher,
      ),
    ).toBeDefined();
  });
});
